
import { useState,  useEffect } from 'react';

import Request, {YWRequestConfig} from '@ywfe/request';
// @ts-ignore
import * as querystring from 'querystring';
// @ts-ignore
import { ParsedUrlQueryInput } from 'querystring';
// @ts-ignore
import * as R from 'ramda';
import {configs} from './config';


  const projectId = "PROAUTH";
  let env;
  if(typeof window === 'undefined'){
    env = (process.env.REACT_APP_ENV === 'prod' ? 'prod': process.env.REACT_APP_ENV) || 'prod';
  } else {
    env = window.localStorage.getItem('env') || (process.env.REACT_APP_ENV === 'prod' ? 'prod': process.env.REACT_APP_ENV) || 'prod';
  }
  
  const basePath = configs[projectId] ? configs[projectId][env].API_BASE_URL + `${env === 'mock' ? '/' + 88 : ''}` : '';
  const loginPath = configs['AUTH'] ? configs['AUTH'][env].APPLICATION_URL : '';
  

  

// @ts-ignore




export interface DesktopHomeCommonFunctionDeleteInput {
  
    
    /** 排序资源 ,String */
    resourceIdList?: any[];
  
}

export interface DesktopHomeCommonFunctionDeleteData {
  
}


const reduceParams = (data: R.Dictionary<DesktopHomeCommonFunctionDeleteInput>) => {
  if(data instanceof FormData){
    return data;
  }
  const result = R.filter(item => !R.isNil(item) && !R.isEmpty(item))(data) || {};
  return result as unknown as DesktopHomeCommonFunctionDeleteInput;
}


// 20969 删除常用功能

  export const usePostDesktopHomeCommonFunctionDelete = () => {
    let isMount = true;
    const [isDesktopHomeCommonFunctionDeleteLoading, setIsDesktopHomeCommonFunctionDeleteLoading] = useState(false);
    const [dataDesktopHomeCommonFunctionDelete, setDataDesktopHomeCommonFunctionDelete] = useState<DesktopHomeCommonFunctionDeleteData>({} as DesktopHomeCommonFunctionDeleteData);
    const postDesktopHomeCommonFunctionDeleteData = async(inputs: DesktopHomeCommonFunctionDeleteInput, config?: YWRequestConfig): Promise<DesktopHomeCommonFunctionDeleteData> => {
      
        const params = reduceParams(inputs as unknown as R.Dictionary<DesktopHomeCommonFunctionDeleteInput>) || {};
      
      if(isMount){
        setIsDesktopHomeCommonFunctionDeleteLoading(true);
      }
      
      try{
        
          
          
          const res: any = await Request.post<DesktopHomeCommonFunctionDeleteData>(`${basePath}/desktop/home/common/function/delete`, params, {
            loginHost: loginPath,
            ...config
          });
          
          
          if(isMount){
            setDataDesktopHomeCommonFunctionDelete(res || {});
            setIsDesktopHomeCommonFunctionDeleteLoading(false);
          }
          return res;
      } catch(error){
        console.log(error);
        if(isMount){
          setIsDesktopHomeCommonFunctionDeleteLoading(false);
        }
        return false as unknown as DesktopHomeCommonFunctionDeleteData;
      }
      
    }

    useEffect(() => {
      return () => {
        isMount = false;
      };
    }, []);
  
    return {
      isDesktopHomeCommonFunctionDeleteLoading,
      dataDesktopHomeCommonFunctionDelete,
      postDesktopHomeCommonFunctionDeleteData,
    }
  }

